/*
 * USB-MIDI class driver sample sketch for GR-SAKURA
 * Copyright 2012-14 Yuuichi Akagawa
 *
 *******************************************************************************
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>
 *******************************************************************************
 */
#include <rxduino.h>
#include "usbh_midi.h"

//////////////////////////
// MIDI Pin assign
// 2 : GND
// 4 : +3.3V(Vcc) with 220ohm
// 5 : TX(IO1)
//////////////////////////

unsigned char buf[3];
USBH_MIDI midi(true);

void setup()
{
    Serial.begin(31500,SCI_SCI0P2x);
}

void loop()
{
    if( midi.isConnected() == false ){
        delay(100);
        return;
    }
    if( midi.read(buf) ) { //f[^΃VAɑM
//        printf("%02x %02x %02x\n", buf[0], buf[1], buf[2]);
        Serial.write(buf, 3);
    }
    delay(midi.getInterval());
}
