/*
 * USB-MIDI class driver sample sketch for GR-SAKURA
 * Copyright 2012-2014 Yuuichi Akagawa
 *
 *******************************************************************************
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>
 *******************************************************************************
 */
#include <rxduino.h>
#include <stdio.h>
#include <math.h>
#include "usbh_midi.h"

//IO8,9,10@  FullColor LED1
//IO11,12,13 FullColor LED2
//KORG nanoKONTROLgpB
// XC_[1 : Control# 2
// XC_[2 : Control# 3
// XC_[3 : Control# 4
// XC_[4 : Control# 5
// XC_[5 : Control# 6
// XC_[6 : Control# 8

 
unsigned char buf[3];
USBH_MIDI midi(true);

int getValue(unsigned char v)
{
    int val;
    float fval = (float)v / 255;
    fval = (fval * fval) * 255;
    if(fval < 0) {
        val = 0;
    }else if (fval > 255){
        val = 255;
    }else{
        val = (int)fval;
    }
    val = 255 - (val / 2);

    return(val);
}

void ledOut()
{
    if( buf[1] == 2 ){
         analogWrite(8, getValue(buf[2]));
    }
    if( buf[1] == 3 ){
        analogWrite(9, getValue(buf[2]));
    }
    if( buf[1] == 4 ){
        analogWrite(10, getValue(buf[2]));
    }
    if( buf[1] == 5 ){
        analogWrite(11, getValue(buf[2]));
    }
    if( buf[1] == 6 ){
        analogWrite(12, getValue(buf[2]));
    }
    if( buf[1] == 8 ){
        analogWrite(13, getValue(buf[2]));
    }
}

void setup()
{
}

void loop()
{
    if( midi.isConnected() == false ){
        delay(100);
        return;
    }
    
    if( midi.read(buf) ) {
//        printf("%02x %02x %02x\n", buf[0], buf[1], buf[2]);
        if(buf[0] == 0xb0){ //XC_[ControlChangebZ[W
            ledOut();
        }
    }
    delay(midi.getInterval());
}
