/*
 * USB-MIDI class driver sample sketch for GR-SAKURA
 * Copyright 2012-2014 Yuuichi Akagawa
 *
 *******************************************************************************
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>
 *******************************************************************************
 */
#include <rxduino.h>
#include "usbh_midi.h"

unsigned char buf[3];
USBH_MIDI midi(true);
int count;
byte bNote;

void setup()
{
   buf[1] = 60; //C3
   buf[2] = 127;
   count = 0;
   bNote = 0x90;
}

void loop()
{
    if( midi.isConnected() == false ){
        delay(100);
        return;
    }
    
    //send note on/off if monaka connected
    if( midi.getVendorId() == 0x16c0 && midi.getProductId() == 0x05e4) {
        buf[0] = bNote ;
        count++;
        if( count == 50 ){
            bNote = (bNote==0x90) ? 0x80 : 0x90;
            count = 0;
         }
         midi.write(buf, 1);
    }
    delay(midi.getInterval());
}
