/*
 * USB-MIDI class driver sample sketch for GR-SAKURA
 * eVY1 Shield sample - Say 'Konnichiwa'
 * Copyright 2014 Yuuichi Akagawa
 *
 *******************************************************************************
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>
 *******************************************************************************
 */
#include <rxduino.h>
#include "usbh_midi.h"

USBH_MIDI midi(true);

void MIDI_poll();
void noteOn(uint8_t note);
void noteOff(uint8_t note);

word pid, vid;
byte exdata[] = {
  0xf0, 0x43, 0x79, 0x09, 0x00, 0x50, 0x10, 
  'k',' ','o',',',    //Ko
  'N','\\',',',       //N
  'J',' ', 'i', ',',  //Ni
  't','S',' ','i',',',//Chi
  'w',' ','a',        //Wa
  0x00, 0xf7
};

void setup()
{
   vid = pid = 0;
}

void loop()
{
    if( midi.isConnected() == false ){
        delay(100);
        return;
    }
    
    MIDI_poll();
    noteOn(0x3f);
    delay(400);
    noteOff(0x3f);
    delay(100);
}

// Poll USB MIDI Controler
void MIDI_poll()
{
    byte inBuf[ 3 ];
    
    //first call?
    if(midi.getVendorId() != vid || midi.getProductId() != pid){
      vid = midi.getVendorId(); pid = midi.getProductId();
      midi.writeSysEx(exdata, sizeof(exdata));
//      Midi.SendData(exdata);
      delay(500);
    }
    int size = midi.read(inBuf);
}

//note On
void noteOn(uint8_t note)
{
    byte buf[3];
    buf[0] = 0x90;
    buf[1] = note;
    buf[2] = 0x7f;
    midi.write(buf);
}

//note Off
void noteOff(uint8_t note)
{
    byte buf[3];
    buf[0] = 0x80;
    buf[1] = note;
    buf[2] = 0x00;
    midi.write(buf);
}
